<Cabbage>
form caption("StepRouter") size(620, 510) guiMode("queue") pluginId("Srtr") colour("black") bundle("./images", "StepRouter.snaps")

; Plugin menu controls
image bounds(25, 25, 140, 33) channel("panelMenu") colour("black")
{
    combobox bounds(0, 0, 55, 16) channel("PluginResizerCombBox") mode("resize") value(3) automatable(0)
    filebutton bounds(60, 0, 16, 16) channel("btnSave") mode("named preset") populate("*.snaps") text("") imgFile("off", "./images/save-white.svg") imgFile("on", "./images/save-white.svg")
    filebutton bounds(81, 0, 16, 16) channel("btnDelete") mode("remove preset") populate("*.snaps") text("") imgFile("off", "./images/delete-white.svg") imgFile("on", "./images/delete-white.svg")
    button bounds(102, 0, 16, 16) channel("btnRandom") text("") presetIgnore(1) imgFile("off", "./images/randomize-white.svg") imgFile("on", "./images/randomize-white.svg")
    button bounds(123, 0, 16, 16) channel("btnClear") text("") presetIgnore(1) imgFile("off", "./images/clear-white.svg") imgFile("on", "./images/clear-white.svg")
    combobox bounds(0, 17, 140, 16) channel("combBoxPresets") populate("*.snaps")
}

; Plugin title
image bounds(190, 27, 240, 30) channel("lblTitle") file("./images/steprouter-title.png")

; Host info
image bounds(430, 25, 120, 33) channel("panelHost") colour("black")
{
    label bounds(0, 0, 120, 16) channel("lblBPM") text("0 BPM")
    label bounds(0, 17, 120, 16) channel("lblTimeSig") text("0/0")
}

; Help link
infobutton bounds(305, 61, 10, 16) channel("btnHelp") file("https://github.com/niflheimmer/steprouter") text("") imgFile("off", "./images/question-white.svg") imgFile("on", "./images/question-white.svg")

; Power
image bounds(550, 13, 37, 52) channel("panelPower") colour("black")
{
    button bounds(3, 0, 30, 32) channel("btnPower") text("") value(1) presetIgnore(1) corners(15) imgFile("off", "./images/power-grey.svg") imgFile("on", "./images/power-white.svg")
    label bounds(0, 37, 37, 16) channel("lblPower") text("PWR") fontColour("white")
}
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d
</CsOptions>
<CsInstruments>
nchnls_i = 32
nchnls = 32
0dbfs = 1

instr startup
    ; set grid dimensions
    iGridX = 25
    iGridY = 85
    iGridWH = 25
    iGridRad = int(iGridWH / 2 + 1)
    iGridPad = 5

    ; set colors
    SColors[] init 16
    SColors[0] = "brown"
    SColors[1] = "crimson"
    SColors[2] = "salmon"
    SColors[3] = "coral"
    SColors[4] = "gold"
    SColors[5] = "khaki"
    SColors[6] = "greenyellow"
    SColors[7] = "lime"
    SColors[8] = "mediumspringgreen"
    SColors[9] = "mediumaquamarine"
    SColors[10] = "turquoise"
    SColors[11] = "skyblue"
    SColors[12] = "mediumslateblue"
    SColors[13] = "violet"
    SColors[14] = "magenta"
    SColors[15] = "hotpink"

    ; set indexes
    iX init 0
    iY init 0
    
    ; create widgets for each row
    while iY < 16 do
        ; determine one-digit label
        iLbl = iY < 9 ? iY + 1 : iY - 9
        
        ; set parameters for every widget
        SPwrBtn sprintf "bounds(%d, %d, %d, %d) channel(\"btnOn%d\") text(\"%d\") value(0) corners(%d) colour:0(\"grey\") colour:1(\"%s\") outlineColour(\"white\") fontColour:0(\"white\") fontColour:1(\"black\")",
            iGridX, (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, iLbl, iGridRad, SColors[iY]
        SGainKnob sprintf "bounds(%d, %d, %d, %d) channel(\"knobGain%d\") range(0, 2, 1, 1, 0.01) popupPrefix(\"Gain: \") colour(\"black\") markerColour(\"white\") outlineColour(\"grey\") trackerColour(\"%s\")",
            (iGridX + iGridWH + iGridPad), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, SColors[iY]
        SNumKnob sprintf "bounds(%d, %d, %d, %d) channel(\"knobStepNum%d\") range(1, 16, 16, 1, 1) popupPostfix(\" steps\") colour(\"black\") markerColour(\"white\") outlineColour(\"grey\") trackerColour(\"%s\")",
            (iGridX + iGridWH*18 + iGridPad*3), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, SColors[iY]
        SLenKnob sprintf "bounds(%d, %d, %d, %d) channel(\"knobStepLen%d\") range(0, 5, 0, 1, 1) popupText(\"Step Length\") colour(\"black\") markerColour(\"white\") outlineColour(\"grey\") trackerColour(\"%s\")",
            (iGridX + iGridWH*19 + iGridPad*4), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, SColors[iY]
        SLenLbl sprintf "bounds(%d, %d, 45, 16) channel(\"lblStepLen%d\") visible(0) text(\"Whole\") align(\"left\") fontStyle(\"plain\") fontColour(\"white\")",
            (iGridX + iGridWH*20 + iGridPad*5), (iGridY + iY * iGridWH + 4), iY
        
        ; create widgets
        cabbageCreate "button", SPwrBtn
        cabbageCreate "rslider", SGainKnob
        cabbageCreate "rslider", SNumKnob
        cabbageCreate "rslider", SLenKnob
        cabbageCreate "label", SLenLbl
        
        ; create sequence buttons
        iX = 0
        while iX < 16 do
            SSeqBtn sprintf "bounds(%d, %d, %d, %d) channel(\"btnSeq%dStep%d\") text(\"\") corners(%d) colour:0(\"grey\") colour:1(\"%s\") outlineColour(\"white\")",
                (iGridX + iGridWH*2 + iGridPad*2 + iX * iGridWH), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, iX, iGridRad, SColors[iY]
            cabbageCreate "button", SSeqBtn
            iX += 1
        od
        iY += 1
    od
endin

instr main
    ; get host info
    gkIsPlaying cabbageGetValue "IS_PLAYING"
    gkBPM cabbageGetValue "HOST_BPM"
    gkTimeSigNum cabbageGetValue "TIME_SIG_NUM"
    gkTimeSigDenom cabbageGetValue "TIME_SIG_DENOM"

    ; get plugin info
    gkPower cabbageGetValue "btnPower"
    kRandom cabbageGetValue "btnRandom"
    kClear cabbageGetValue "btnClear"

    ; init sequence info
    gkTriggers[] init 16
    gkStepIndexes[] init 16
    gkLastStepIndexes[] init 16
    gkSeqMem[] init 16
    
    ; init channel names
    SOnChnls[] init 16
    SGainChnls[] init 16
    SStepNumChnls[] init 16
    SStepLenChnls[] init 16
    
    ; set indexes
    iY init 0
    kStepVisible init 16
    
    ; set triggers, indexes, & channel names
    while iY < 16 do
        gkTriggers[iY] = 0
        gkStepIndexes[iY] = 0
        gkLastStepIndexes[iY] = -1
        gkSeqMem[iY] = 0
        
        SOnChnl sprintf "btnOn%d", iY
        SGainChnl sprintf "knobGain%d", iY
        SStepNumChnl sprintf "knobStepNum%d", iY
        SStepLenChnl sprintf "knobStepLen%d", iY
        
        SOnChnls[iY] = SOnChnl
        SGainChnls[iY] = SGainChnl
        SStepNumChnls[iY] = SStepNumChnl
        SStepLenChnls[iY] = SStepLenChnl
        
        iY += 1
    od
    
    ; set row info
    gkOn[] init 16
    gkGain[] init 16
    gkStepNum[] init 16
    gkStepLen[] init 16
    
    gkOn[] cabbageGetValue SOnChnls
    gkGain[] cabbageGetValue SGainChnls
    gkStepNum[] cabbageGetValue SStepNumChnls
    gkStepLen[] cabbageGetValue SStepLenChnls

    ; set metronome speed
    ; hardcoded for "divz" opcode
    gkMetroSpeed[] init 16
    gkMetroSpeed[0] divz (gkBPM * (2^gkStepLen[0])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[1] divz (gkBPM * (2^gkStepLen[1])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[2] divz (gkBPM * (2^gkStepLen[2])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[3] divz (gkBPM * (2^gkStepLen[3])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[4] divz (gkBPM * (2^gkStepLen[4])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[5] divz (gkBPM * (2^gkStepLen[5])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[6] divz (gkBPM * (2^gkStepLen[6])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[7] divz (gkBPM * (2^gkStepLen[7])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[8] divz (gkBPM * (2^gkStepLen[8])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[9] divz (gkBPM * (2^gkStepLen[9])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[10] divz (gkBPM * (2^gkStepLen[10])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[11] divz (gkBPM * (2^gkStepLen[11])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[12] divz (gkBPM * (2^gkStepLen[12])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[13] divz (gkBPM * (2^gkStepLen[13])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[14] divz (gkBPM * (2^gkStepLen[14])), (60 * gkTimeSigNum), 4
    gkMetroSpeed[15] divz (gkBPM * (2^gkStepLen[15])), (60 * gkTimeSigNum), 4

    ; set step length names
    SStepLens[] init 6
    SStepLens[0] = "Whole"
    SStepLens[1] = "Half"
    SStepLens[2] = "Qtr"
    SStepLens[3] = "8th"
    SStepLens[4] = "16th"
    SStepLens[5] = "32nd"

    ; update BPM view
    if changed(gkBPM) == 1 then
        cabbageSet 1, "lblBPM", "text", sprintfk("%d BPM", gkBPM)
    endif

    ; update time signature view
    if changed(gkTimeSigNum) == 1 || changed(gkTimeSigDenom) == 1 then
        cabbageSet 1, "lblTimeSig", "text", sprintfk("%d/%d", gkTimeSigNum, gkTimeSigDenom)
    endif
    
    ; update entire plugin on preset change
    SCombBoxPreset[] init 1
    SCombBoxPreset[0] = "combBoxPresets"
    kI, kPreset cabbageChanged SCombBoxPreset, 0, 2
    if kPreset == 1 then
        ; go through all widgets
        kY = 0
        while kY < 16 do
            ; update step length text
            cabbageSet 1, sprintfk("lblStepLen%d", kY), "text", SStepLens[gkStepLen[kY]]
            ; update step length visibility
            cabbageSet 1, sprintfk("lblStepLen%d", kY), "visible", gkOn[kY]
            ; update step button visibility
            kX = 0
            while kX < 16 do
                kStepVisible = kX < gkStepNum[kY] ? 1 : 0
                cabbageSet 1, sprintfk("btnSeq%dStep%d", kY, kX), "visible", kStepVisible
                kX += 1
            od
            kY += 1
        od
    endif

    ; update step length text
    SStepLenChngChnl, kStepLenChng cabbageChanged SStepLenChnls
    if kStepLenChng == 1 then
        ; get row
        SStepLenRow strsubk SStepLenChngChnl, 11, -1
        ; init row for "strtolk" opcode
        SStepLenRow init "0"
        ; convert row str to int
        kY strtolk SStepLenRow
        ; set text value
        cabbageSet 1, sprintfk("lblStepLen%d", kY), "text", SStepLens[gkStepLen[kY]]
    endif
    
    ; update step length visibility & enable sequencer if during playback
    SOnChngChnl, kOnChng cabbageChanged SOnChnls
    if kOnChng == 1 then
        ; get row
        SOnRow strsubk SOnChngChnl, 5, -1
        ; init row for "strtolk" opcode
        SOnRow init "0"
        ; convert row str to int
        kY strtolk SOnRow
        ; set visibility
        cabbageSet 1, sprintfk("lblStepLen%d", kY), "visible", gkOn[kY]
        
        ; enable sequencer if during playback
        if gkIsPlaying == 1 && gkPower == 1 && gkOn[kY] == 1 && gkSeqMem[kY] == 0 then
            ; start sequencer -->              p4
            event "i", "sequencer", 0, 604800, kY
            ; record sequencer into memory
            gkSeqMem[kY] = 1
        endif
    endif

    ; update step button visibility
    SStepNumChngChnl, kStepNumChng cabbageChanged SStepNumChnls
    if kStepNumChng == 1 then
        ; get row
        SStepNumRow strsubk SStepNumChngChnl, 11, -1
        ; init row for "strtolk" opcode
        SStepNumRow init "0"
        ; convert row str to int
        kY strtolk SStepNumRow
        
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible = kX < gkStepNum[kY] ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq%dStep%d", kY, kX), "visible", kStepVisible
            kX += 1
        od
    endif

    ; clear sequence
    if changed(kClear) == 1 || changed(kRandom) == 1 then
        kY = 0
        while kY < 16 do
            kX = 0
            while kX < 16 do
                cabbageSetValue sprintfk("btnSeq%dStep%d", kY, kX), 0, 1
                kX += 1
            od
            kY += 1
        od
    endif

    ; generate random sequences
    if changed(kRandom) == 1 then
        kY = 0
        while kY < 16 do
            kX = 0
            while kX < 16 do
                cabbageSetValue sprintfk("btnSeq%dStep%d", kY, kX), round(rnd:k(1)), 1
                kX += 1
            od
            kY += 1
        od
    endif

    ; trigger sequencers when playback starts
    if changed(gkIsPlaying) == 1 || changed(gkPower) == 1 then
        if gkIsPlaying == 1 && gkPower == 1 then
            ; find all enabled rows
            kY = 0
            while kY < 16 do
                if gkOn[kY] == 1 then
                    ; start sequencer -->              p4
                    event "i", "sequencer", 0, 604800, kY
                    ; record sequencer into memory
                    gkSeqMem[kY] = 1
                endif
                kY += 1
            od
        else
            ; stop sequencers
            turnoff2 "sequencer", 0, 0

            ; reset triggers, indexes, memory, & lights
            kY = 0
            while kY < 16 do
                gkTriggers[kY] = 0
                gkStepIndexes[kY] = 0
                gkLastStepIndexes[kY] = -1
                gkSeqMem[kY] = 0
                
                ; reset row light
                cabbageSet 1, SOnChnls[kY], "outlineThickness", 0
                
                ; reset step lights
                kX = 0
                while kX < 16 do
                    cabbageSet 1, sprintfk("btnSeq%dStep%d", kY, kX), "outlineThickness", 0
                    kX += 1
                od
                kY += 1
            od
        endif
    endif
endin

instr sequencer
    ; get row
    kY = p4
    
    if metro(gkMetroSpeed[kY]) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq%dStep%d", kY, gkLastStepIndexes[kY]), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq%dStep%d", kY, gkStepIndexes[kY]), "outlineThickness", 4
        
        ; toggle output & row light
        gkTriggers[kY] cabbageGetValue sprintfk("btnSeq%dStep%d", kY, gkStepIndexes[kY])
        cabbageSet 1, sprintfk("btnOn%d", kY), "outlineThickness", 4 * gkTriggers[kY]

        ; increment step
        gkLastStepIndexes[kY] = gkStepIndexes[kY]
        gkStepIndexes[kY] = gkStepIndexes[kY] < gkStepNum[kY] - 1 ? gkStepIndexes[kY] + 1 : 0
    endif
endin

instr output    
    ; init channels
    aIns[] init 32
    aOuts[] init 32
    
    ; init indexes
    kI = 0
    kSt = 0
    
    ; get inputs
    aIns in
    
    ; adjust for gain, trigger, & power
    while kSt < 16 do
        ; adjust left stereo channel
        aOuts[kI] = aIns[kI] * gkGain[kSt] * gkTriggers[kSt] * gkOn[kSt]
        kI += 1
        ; adjust right stereo channel
        aOuts[kI] = aIns[kI] * gkGain[kSt] * gkTriggers[kSt] * gkOn[kSt]
        kI += 1
        kSt += 1
    od
    
    ; set outputs
    out aOuts
endin

</CsInstruments>
<CsScore>.
f0 z
i "startup" 0 0
i "main" 0 604800
i "output" 0 604800
</CsScore>
</CsoundSynthesizer>